﻿local DF = DF_namespace
local _
local _G = getfenv(0);

local targetFramesFilter ={
"CharacterStats",
"PaperDoll",
"Glyph",
"EncounterJournal",
"Auction",
"BrowseB",
"Achievement",
"Arch-",
"Archaeology",
"Arena",
"Barbershop",
"BlackMarket",
"Challenges",
"UI-EJ",
"Encounter",
"GuildBank",
"RankChange",
"Guild",
"Inspect",
"Ethereal",
"ItemSocketing",
"ItemUpgrade",
"Macro",
"PetBattle",
"PetBattle",
"PetList",
"BattleSlot",
"PetCard",
"Reforging",
"PlayerSpec",
"PlayerTalent",
"Token",
"TradeSkill",
"ClassTrainer",
}

local function isOnList(nom)

	local nb = getn(targetFramesFilter)
	
	for i = 1,nb do
		
		if string.find(nom, targetFramesFilter[i]) then
			return true
		end
		
	end
	
	return false
	
end

local function SetLevel(nom)

	local objet
	local parent
  local objetLevel
	local parentLevel
				  
	if nom and type(nom)=="string" then
		
		objet=_G[nom]
		
		if objet then
				
		  if objet.SetFrameLevel and objet.GetFrameLevel then
				
			  parent = objet:GetParent()
			
			  if parent and parent.GetFrameLevel then
				
					parentLevel=parent:GetFrameLevel()
					objetLevel = objet:GetFrameLevel()
			
					if parentLevel and objetLevel and objetLevel<=parentLevel then
						
						objet:SetFrameLevel(parentLevel+1)
						
						--DEFAULT_CHAT_FRAME:AddMessage(tostring(nom).." fixed to "..tostring(parentLevel+1))
								
					end
					
				end
			
			end

		end
		
	end
	  
end

local function checkLevel(frametype,nom)

	local objet
	local parentLevel
	local parent
  local cadreLevel
	local debugMsg
	local childrens
	local withChildrens=true

	if nom and type(nom)=="string" then	

		objet=_G[nom]		  
	
		if objet then
		
			if objet.SetFrameLevel then
			
				if isOnList(nom) then
					
					--DEFAULT_CHAT_FRAME:AddMessage("Check "..tostring(nom))		
					
					SetLevel(nom)
			
					if withChildrens then
						
						childrens = {objet:GetChildren()}
						
						for _, child in ipairs(childrens) do
								  
						  SetLevel(child:GetName())
						  
						end
														
					end
	
				end
			
			end
			
		end
		
	end
	  
end

function DF:strata_fixAllFrames()
	
  local cadre = EnumerateFrames(); 
 	local nom
	
  while cadre do
	  
	  nom=cadre:GetName()
	  
		checkLevel(nil,nom)
		  
    cadre = EnumerateFrames(cadre);
    
  end
  
end

local function strata_fixLevel_CreateFrame(...)

	checkLevel(...)

end

hooksecurefunc("CreateFrame", strata_fixLevel_CreateFrame)
